##
##  dsh.spec -- OpenPKG RPM Specification
##  Copyright (c) 2000-2003 Cable & Wireless Deutschland GmbH
##  Copyright (c) 2000-2003 The OpenPKG Project <http://www.openpkg.org/>
##  Copyright (c) 2000-2003 Ralf S. Engelschall <rse@engelschall.com>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package versions
%define       V_dsh       0.23.5
%define       V_dshconfig 0.20.8

#   package information
Name:         dsh
Summary:      Dancer's Distributed shell
URL:          http://www.netfort.gr.jp/~dancer/software/dsh.html
Vendor:       Junichi Uekawa
Packager:     The OpenPKG Project
Distribution: OpenPKG [EVAL]
Group:        Shell
License:      GPL
Version:      %{V_dsh}
Release:      20030101

#   list of sources
Source0:      http://www.netfort.gr.jp/~dancer/software/downloads/dsh-%{V_dsh}.tar.gz
Source1:      http://www.netfort.gr.jp/~dancer/software/downloads/libdshconfig-%{V_dshconfig}.tar.gz
Source2:      dsh.conf

#   build information
Prefix:       %{l_prefix}
BuildRoot:    %{l_buildroot}
BuildPreReq:  OpenPKG, openpkg >= 20021230
PreReq:       OpenPKG, openpkg >= 20021230, openssh
AutoReq:      no
AutoReqProv:  no

%description
    Dsh executes commands remotely via SSH on several different machines
    at the same time.

%prep
    %setup0 -q
    %setup1 -q -T -D -a 1

%build
    #   build libdshconfig
    ( cd libdshconfig-%{V_dshconfig}
      CC="%{l_cc}" \
      CFLAGS="%{l_cflags -O}" \
      CPPFLAGS="%{l_cppflags}" \
      LDFLAGS="%{l_ldflags}" \
      ./configure \
          --prefix=%{l_prefix} \
          --disable-shared \
          --disable-nls
      %{l_shtool} subst -e 's;ssize_t;int;g' -- libdshconfig.c
      %{l_make} %{l_mflags -O}
      rm -f .libs/*.la*
    )

    #   build dsh
    %{l_shtool} subst \
        -e 's;/etc\(/dsh/dsh.conf\);%{l_prefix}/etc\1;' \
        -e 's;/etc\(/dsh/machines.list\);%{l_prefix}/etc\1;' \
        -e 's;/etc\(/dsh/group\);%{l_prefix}/etc\1;' \
        -- dsh.1
    CC="%{l_cc}" \
    CFLAGS="%{l_cflags -O}" \
    CPPFLAGS="%{l_cppflags} -I`pwd`/libdshconfig-%{V_dshconfig}" \
    LDFLAGS="%{l_ldflags} -L`pwd`/libdshconfig-%{V_dshconfig}/.libs" \
    ./configure \
        --prefix=%{l_prefix} \
        --sysconfdir=%{l_prefix}/etc/dsh \
        --disable-shared \
        --disable-nls
    %{l_make} %{l_mflags -O}

%install
    rm -rf $RPM_BUILD_ROOT

    #   perform standard installation procedure
    %{l_make} %{l_mflags} install AM_MAKEFLAGS="DESTDIR=$RPM_BUILD_ROOT"
    strip $RPM_BUILD_ROOT%{l_prefix}/bin/* >/dev/null 2>&1 || true

    #   add reasonable default configuration
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/etc/dsh/group
    %{l_shtool} install -c -m 644 \
        -e 's;@l_prefix@;%{l_prefix};g' \
        %{SOURCE dsh.conf} $RPM_BUILD_ROOT%{l_prefix}/etc/dsh/
    echo "localhost" >conf
    %{l_shtool} install -c -m 644 \
        conf $RPM_BUILD_ROOT%{l_prefix}/etc/dsh/machines.list
    %{l_shtool} install -c -m 644 \
        conf $RPM_BUILD_ROOT%{l_prefix}/etc/dsh/group/localhost

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT \
        %{l_files_std} \
        '%config %{l_prefix}/etc/dsh/dsh.conf' \
        '%config %{l_prefix}/etc/dsh/machines.list' \
        '%config %{l_prefix}/etc/dsh/group/localhost'

%files -f files

%clean
    rm -rf $RPM_BUILD_ROOT

